/*** Subroutine ***/
/*** Procedure, function, parameter passing, recursion ***/

#include<stdio.h>

void stars(int n){  //procedure
   for(;n>0;n--)
      printf("*");
   }

int fact1(int n){  //function (iteratve)
   int f=1;
   for(;n>1;n--)
      f*=n;
   return f;
   }

int fact2(int n){  //function (recursive)
   if(n==1) return 1;
   return n*fact2(n-1);
   }

void more(float n, float* smaller, float* larger){  // parameter passing by 'pseudo-address'
   *smaller  = n-1;
   *larger = n+1;
   }

int main(){
   int i=5;
   float n=2.4,l,s;
   stars(5);
   printf("\n%d! = %d (iterative)\n",i,fact1(i));
   printf("%d! = %d (recursive)\n",i,fact2(i));
   more(n,&s,&l);
   printf("%.1f-1=%.1f\t%.1f+1=%.1f\n",n,s,n,l);
   return 0;
   }
